Imported Upstream version 2.13.7
[platform/upstream/git.git] / git-submodule.sh
1 #!/bin/sh
2 #
3 # git-submodule.sh: add, init, update or list git submodules
4 #
5 # Copyright (c) 2007 Lars Hjemli
6
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9    or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10    or: $dashless [--quiet] init [--] [<path>...]
11    or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
12    or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
13    or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14    or: $dashless [--quiet] foreach [--recursive] <command>
15    or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
16    or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
17 OPTIONS_SPEC=
18 SUBDIRECTORY_OK=Yes
19 . git-sh-setup
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
24
25 # Tell the rest of git that any URLs we get don't come
26 # directly from the user, so it can apply policy as appropriate.
27 GIT_PROTOCOL_FROM_USER=0
28 export GIT_PROTOCOL_FROM_USER
29
30 command=
31 branch=
32 force=
33 reference=
34 cached=
35 recursive=
36 init=
37 files=
38 remote=
39 nofetch=
40 update=
41 prefix=
42 custom_name=
43 depth=
44 progress=
45
46 die_if_unmatched ()
47 {
48         if test "$1" = "#unmatched"
49         then
50                 exit ${2:-1}
51         fi
52 }
53
54 #
55 # Print a submodule configuration setting
56 #
57 # $1 = submodule name
58 # $2 = option name
59 # $3 = default value
60 #
61 # Checks in the usual git-config places first (for overrides),
62 # otherwise it falls back on .gitmodules.  This allows you to
63 # distribute project-wide defaults in .gitmodules, while still
64 # customizing individual repositories if necessary.  If the option is
65 # not in .gitmodules either, print a default value.
66 #
67 get_submodule_config () {
68         name="$1"
69         option="$2"
70         default="$3"
71         value=$(git config submodule."$name"."$option")
72         if test -z "$value"
73         then
74                 value=$(git config -f .gitmodules submodule."$name"."$option")
75         fi
76         printf '%s' "${value:-$default}"
77 }
78
79 isnumber()
80 {
81         n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
82 }
83
84 # Sanitize the local git environment for use within a submodule. We
85 # can't simply use clear_local_git_env since we want to preserve some
86 # of the settings from GIT_CONFIG_PARAMETERS.
87 sanitize_submodule_env()
88 {
89         save_config=$GIT_CONFIG_PARAMETERS
90         clear_local_git_env
91         GIT_CONFIG_PARAMETERS=$save_config
92         export GIT_CONFIG_PARAMETERS
93 }
94
95 #
96 # Add a new submodule to the working tree, .gitmodules and the index
97 #
98 # $@ = repo path
99 #
100 # optional branch is stored in global branch variable
101 #
102 cmd_add()
103 {
104         # parse $args after "submodule ... add".
105         reference_path=
106         while test $# -ne 0
107         do
108                 case "$1" in
109                 -b | --branch)
110                         case "$2" in '') usage ;; esac
111                         branch=$2
112                         shift
113                         ;;
114                 -f | --force)
115                         force=$1
116                         ;;
117                 -q|--quiet)
118                         GIT_QUIET=1
119                         ;;
120                 --reference)
121                         case "$2" in '') usage ;; esac
122                         reference_path=$2
123                         shift
124                         ;;
125                 --reference=*)
126                         reference_path="${1#--reference=}"
127                         ;;
128                 --name)
129                         case "$2" in '') usage ;; esac
130                         custom_name=$2
131                         shift
132                         ;;
133                 --depth)
134                         case "$2" in '') usage ;; esac
135                         depth="--depth=$2"
136                         shift
137                         ;;
138                 --depth=*)
139                         depth=$1
140                         ;;
141                 --)
142                         shift
143                         break
144                         ;;
145                 -*)
146                         usage
147                         ;;
148                 *)
149                         break
150                         ;;
151                 esac
152                 shift
153         done
154
155         if test -n "$reference_path"
156         then
157                 is_absolute_path "$reference_path" ||
158                 reference_path="$wt_prefix$reference_path"
159
160                 reference="--reference=$reference_path"
161         fi
162
163         repo=$1
164         sm_path=$2
165
166         if test -z "$sm_path"; then
167                 sm_path=$(printf '%s\n' "$repo" |
168                         sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
169         fi
170
171         if test -z "$repo" || test -z "$sm_path"; then
172                 usage
173         fi
174
175         is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
176
177         # assure repo is absolute or relative to parent
178         case "$repo" in
179         ./*|../*)
180                 test -z "$wt_prefix" ||
181                 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
182
183                 # dereference source url relative to parent's url
184                 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
185                 ;;
186         *:*|/*)
187                 # absolute url
188                 realrepo=$repo
189                 ;;
190         *)
191                 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
192         ;;
193         esac
194
195         # normalize path:
196         # multiple //; leading ./; /./; /../; trailing /
197         sm_path=$(printf '%s/\n' "$sm_path" |
198                 sed -e '
199                         s|//*|/|g
200                         s|^\(\./\)*||
201                         s|/\(\./\)*|/|g
202                         :start
203                         s|\([^/]*\)/\.\./||
204                         tstart
205                         s|/*$||
206                 ')
207         if test -z "$force"
208         then
209                 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
210                 die "$(eval_gettext "'\$sm_path' already exists in the index")"
211         else
212                 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
213                 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
214         fi
215
216         if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
217         then
218                 eval_gettextln "The following path is ignored by one of your .gitignore files:
219 \$sm_path
220 Use -f if you really want to add it." >&2
221                 exit 1
222         fi
223
224         if test -n "$custom_name"
225         then
226                 sm_name="$custom_name"
227         else
228                 sm_name="$sm_path"
229         fi
230
231         if ! git submodule--helper check-name "$sm_name"
232         then
233                 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
234         fi
235
236         # perhaps the path exists and is already a git repo, else clone it
237         if test -e "$sm_path"
238         then
239                 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
240                 then
241                         eval_gettextln "Adding existing repo at '\$sm_path' to the index"
242                 else
243                         die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
244                 fi
245
246         else
247                 if test -d ".git/modules/$sm_name"
248                 then
249                         if test -z "$force"
250                         then
251                                 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
252                                 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^,"  ", -e s,' (fetch)',, >&2
253                                 die "$(eval_gettextln "\
254 If you want to reuse this local git directory instead of cloning again from
255   \$realrepo
256 use the '--force' option. If the local git directory is not the correct repo
257 or you are unsure what this means choose another name with the '--name' option.")"
258                         else
259                                 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
260                         fi
261                 fi
262                 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
263                 (
264                         sanitize_submodule_env
265                         cd "$sm_path" &&
266                         # ash fails to wordsplit ${branch:+-b "$branch"...}
267                         case "$branch" in
268                         '') git checkout -f -q ;;
269                         ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
270                         esac
271                 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
272         fi
273         git config submodule."$sm_name".url "$realrepo"
274
275         git add $force "$sm_path" ||
276         die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
277
278         git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
279         git config -f .gitmodules submodule."$sm_name".url "$repo" &&
280         if test -n "$branch"
281         then
282                 git config -f .gitmodules submodule."$sm_name".branch "$branch"
283         fi &&
284         git add --force .gitmodules ||
285         die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
286
287         # NEEDSWORK: In a multi-working-tree world, this needs to be
288         # set in the per-worktree config.
289         if git config --get submodule.active >/dev/null
290         then
291                 # If the submodule being adding isn't already covered by the
292                 # current configured pathspec, set the submodule's active flag
293                 if ! git submodule--helper is-active "$sm_path"
294                 then
295                         git config submodule."$sm_name".active "true"
296                 fi
297         else
298                 git config submodule."$sm_name".active "true"
299         fi
300 }
301
302 #
303 # Execute an arbitrary command sequence in each checked out
304 # submodule
305 #
306 # $@ = command to execute
307 #
308 cmd_foreach()
309 {
310         # parse $args after "submodule ... foreach".
311         while test $# -ne 0
312         do
313                 case "$1" in
314                 -q|--quiet)
315                         GIT_QUIET=1
316                         ;;
317                 --recursive)
318                         recursive=1
319                         ;;
320                 -*)
321                         usage
322                         ;;
323                 *)
324                         break
325                         ;;
326                 esac
327                 shift
328         done
329
330         toplevel=$(pwd)
331
332         # dup stdin so that it can be restored when running the external
333         # command in the subshell (and a recursive call to this function)
334         exec 3<&0
335
336         {
337                 git submodule--helper list --prefix "$wt_prefix" ||
338                 echo "#unmatched" $?
339         } |
340         while read -r mode sha1 stage sm_path
341         do
342                 die_if_unmatched "$mode" "$sha1"
343                 if test -e "$sm_path"/.git
344                 then
345                         displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
346                         say "$(eval_gettext "Entering '\$displaypath'")"
347                         name=$(git submodule--helper name "$sm_path")
348                         (
349                                 prefix="$prefix$sm_path/"
350                                 sanitize_submodule_env
351                                 cd "$sm_path" &&
352                                 sm_path=$(git submodule--helper relative-path "$sm_path" "$wt_prefix") &&
353                                 # we make $path available to scripts ...
354                                 path=$sm_path &&
355                                 if test $# -eq 1
356                                 then
357                                         eval "$1"
358                                 else
359                                         "$@"
360                                 fi &&
361                                 if test -n "$recursive"
362                                 then
363                                         cmd_foreach "--recursive" "$@"
364                                 fi
365                         ) <&3 3<&- ||
366                         die "$(eval_gettext "Stopping at '\$displaypath'; script returned non-zero status.")"
367                 fi
368         done
369 }
370
371 #
372 # Register submodules in .git/config
373 #
374 # $@ = requested paths (default to all)
375 #
376 cmd_init()
377 {
378         # parse $args after "submodule ... init".
379         while test $# -ne 0
380         do
381                 case "$1" in
382                 -q|--quiet)
383                         GIT_QUIET=1
384                         ;;
385                 --)
386                         shift
387                         break
388                         ;;
389                 -*)
390                         usage
391                         ;;
392                 *)
393                         break
394                         ;;
395                 esac
396                 shift
397         done
398
399         git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet}  "$@"
400 }
401
402 #
403 # Unregister submodules from .git/config and remove their work tree
404 #
405 cmd_deinit()
406 {
407         # parse $args after "submodule ... deinit".
408         deinit_all=
409         while test $# -ne 0
410         do
411                 case "$1" in
412                 -f|--force)
413                         force=$1
414                         ;;
415                 -q|--quiet)
416                         GIT_QUIET=1
417                         ;;
418                 --all)
419                         deinit_all=t
420                         ;;
421                 --)
422                         shift
423                         break
424                         ;;
425                 -*)
426                         usage
427                         ;;
428                 *)
429                         break
430                         ;;
431                 esac
432                 shift
433         done
434
435         if test -n "$deinit_all" && test "$#" -ne 0
436         then
437                 echo >&2 "$(eval_gettext "pathspec and --all are incompatible")"
438                 usage
439         fi
440         if test $# = 0 && test -z "$deinit_all"
441         then
442                 die "$(eval_gettext "Use '--all' if you really want to deinitialize all submodules")"
443         fi
444
445         {
446                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
447                 echo "#unmatched" $?
448         } |
449         while read -r mode sha1 stage sm_path
450         do
451                 die_if_unmatched "$mode" "$sha1"
452                 name=$(git submodule--helper name "$sm_path") || exit
453
454                 displaypath=$(git submodule--helper relative-path "$sm_path" "$wt_prefix")
455
456                 # Remove the submodule work tree (unless the user already did it)
457                 if test -d "$sm_path"
458                 then
459                         # Protect submodules containing a .git directory
460                         if test -d "$sm_path/.git"
461                         then
462                                 die "$(eval_gettext "\
463 Submodule work tree '\$displaypath' contains a .git directory
464 (use 'rm -rf' if you really want to remove it including all of its history)")"
465                         fi
466
467                         if test -z "$force"
468                         then
469                                 git rm -qn "$sm_path" ||
470                                 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
471                         fi
472                         rm -rf "$sm_path" &&
473                         say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
474                         say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
475                 fi
476
477                 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
478
479                 # Remove the .git/config entries (unless the user already did it)
480                 if test -n "$(git config --get-regexp submodule."$name\.")"
481                 then
482                         # Remove the whole section so we have a clean state when
483                         # the user later decides to init this submodule again
484                         url=$(git config submodule."$name".url)
485                         git config --remove-section submodule."$name" 2>/dev/null &&
486                         say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
487                 fi
488         done
489 }
490
491 is_tip_reachable () (
492         sanitize_submodule_env &&
493         cd "$1" &&
494         rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
495         test -z "$rev"
496 )
497
498 fetch_in_submodule () (
499         sanitize_submodule_env &&
500         cd "$1" &&
501         case "$2" in
502         '')
503                 git fetch ;;
504         *)
505                 shift
506                 git fetch $(get_default_remote) "$@" ;;
507         esac
508 )
509
510 #
511 # Update each submodule path to correct revision, using clone and checkout as needed
512 #
513 # $@ = requested paths (default to all)
514 #
515 cmd_update()
516 {
517         # parse $args after "submodule ... update".
518         while test $# -ne 0
519         do
520                 case "$1" in
521                 -q|--quiet)
522                         GIT_QUIET=1
523                         ;;
524                 --progress)
525                         progress="--progress"
526                         ;;
527                 -i|--init)
528                         init=1
529                         ;;
530                 --remote)
531                         remote=1
532                         ;;
533                 -N|--no-fetch)
534                         nofetch=1
535                         ;;
536                 -f|--force)
537                         force=$1
538                         ;;
539                 -r|--rebase)
540                         update="rebase"
541                         ;;
542                 --reference)
543                         case "$2" in '') usage ;; esac
544                         reference="--reference=$2"
545                         shift
546                         ;;
547                 --reference=*)
548                         reference="$1"
549                         ;;
550                 -m|--merge)
551                         update="merge"
552                         ;;
553                 --recursive)
554                         recursive=1
555                         ;;
556                 --checkout)
557                         update="checkout"
558                         ;;
559                 --recommend-shallow)
560                         recommend_shallow="--recommend-shallow"
561                         ;;
562                 --no-recommend-shallow)
563                         recommend_shallow="--no-recommend-shallow"
564                         ;;
565                 --depth)
566                         case "$2" in '') usage ;; esac
567                         depth="--depth=$2"
568                         shift
569                         ;;
570                 --depth=*)
571                         depth=$1
572                         ;;
573                 -j|--jobs)
574                         case "$2" in '') usage ;; esac
575                         jobs="--jobs=$2"
576                         shift
577                         ;;
578                 --jobs=*)
579                         jobs=$1
580                         ;;
581                 --)
582                         shift
583                         break
584                         ;;
585                 -*)
586                         usage
587                         ;;
588                 *)
589                         break
590                         ;;
591                 esac
592                 shift
593         done
594
595         if test -n "$init"
596         then
597                 cmd_init "--" "$@" || return
598         fi
599
600         {
601         git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
602                 ${progress:+"$progress"} \
603                 ${wt_prefix:+--prefix "$wt_prefix"} \
604                 ${prefix:+--recursive-prefix "$prefix"} \
605                 ${update:+--update "$update"} \
606                 ${reference:+"$reference"} \
607                 ${depth:+--depth "$depth"} \
608                 ${recommend_shallow:+"$recommend_shallow"} \
609                 ${jobs:+$jobs} \
610                 "$@" || echo "#unmatched" $?
611         } | {
612         err=
613         while read -r mode sha1 stage just_cloned sm_path
614         do
615                 die_if_unmatched "$mode" "$sha1"
616
617                 name=$(git submodule--helper name "$sm_path") || exit
618                 url=$(git config submodule."$name".url)
619                 if ! test -z "$update"
620                 then
621                         update_module=$update
622                 else
623                         update_module=$(git config submodule."$name".update)
624                         if test -z "$update_module"
625                         then
626                                 update_module="checkout"
627                         fi
628                 fi
629
630                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
631
632                 if test $just_cloned -eq 1
633                 then
634                         subsha1=
635                         case "$update_module" in
636                         merge | rebase | none)
637                                 update_module=checkout ;;
638                         esac
639                 else
640                         subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
641                                 git rev-parse --verify HEAD) ||
642                         die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
643                 fi
644
645                 if test -n "$remote"
646                 then
647                         branch=$(git submodule--helper remote-branch "$sm_path")
648                         if test -z "$nofetch"
649                         then
650                                 # Fetch remote before determining tracking $sha1
651                                 fetch_in_submodule "$sm_path" $depth ||
652                                 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
653                         fi
654                         remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
655                         sha1=$(sanitize_submodule_env; cd "$sm_path" &&
656                                 git rev-parse --verify "${remote_name}/${branch}") ||
657                         die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
658                 fi
659
660                 if test "$subsha1" != "$sha1" || test -n "$force"
661                 then
662                         subforce=$force
663                         # If we don't already have a -f flag and the submodule has never been checked out
664                         if test -z "$subsha1" && test -z "$force"
665                         then
666                                 subforce="-f"
667                         fi
668
669                         if test -z "$nofetch"
670                         then
671                                 # Run fetch only if $sha1 isn't present or it
672                                 # is not reachable from a ref.
673                                 is_tip_reachable "$sm_path" "$sha1" ||
674                                 fetch_in_submodule "$sm_path" $depth ||
675                                 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
676
677                                 # Now we tried the usual fetch, but $sha1 may
678                                 # not be reachable from any of the refs
679                                 is_tip_reachable "$sm_path" "$sha1" ||
680                                 fetch_in_submodule "$sm_path" $depth "$sha1" ||
681                                 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
682                         fi
683
684                         must_die_on_failure=
685                         case "$update_module" in
686                         checkout)
687                                 command="git checkout $subforce -q"
688                                 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
689                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
690                                 ;;
691                         rebase)
692                                 command="git rebase"
693                                 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
694                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
695                                 must_die_on_failure=yes
696                                 ;;
697                         merge)
698                                 command="git merge"
699                                 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
700                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
701                                 must_die_on_failure=yes
702                                 ;;
703                         !*)
704                                 command="${update_module#!}"
705                                 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
706                                 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
707                                 must_die_on_failure=yes
708                                 ;;
709                         *)
710                                 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
711                         esac
712
713                         if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
714                         then
715                                 say "$say_msg"
716                         elif test -n "$must_die_on_failure"
717                         then
718                                 die_with_status 2 "$die_msg"
719                         else
720                                 err="${err};$die_msg"
721                                 continue
722                         fi
723                 fi
724
725                 if test -n "$recursive"
726                 then
727                         (
728                                 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
729                                 wt_prefix=
730                                 sanitize_submodule_env
731                                 cd "$sm_path" &&
732                                 eval cmd_update
733                         )
734                         res=$?
735                         if test $res -gt 0
736                         then
737                                 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
738                                 if test $res -ne 2
739                                 then
740                                         err="${err};$die_msg"
741                                         continue
742                                 else
743                                         die_with_status $res "$die_msg"
744                                 fi
745                         fi
746                 fi
747         done
748
749         if test -n "$err"
750         then
751                 OIFS=$IFS
752                 IFS=';'
753                 for e in $err
754                 do
755                         if test -n "$e"
756                         then
757                                 echo >&2 "$e"
758                         fi
759                 done
760                 IFS=$OIFS
761                 exit 1
762         fi
763         }
764 }
765
766 set_name_rev () {
767         revname=$( (
768                 sanitize_submodule_env
769                 cd "$1" && {
770                         git describe "$2" 2>/dev/null ||
771                         git describe --tags "$2" 2>/dev/null ||
772                         git describe --contains "$2" 2>/dev/null ||
773                         git describe --all --always "$2"
774                 }
775         ) )
776         test -z "$revname" || revname=" ($revname)"
777 }
778 #
779 # Show commit summary for submodules in index or working tree
780 #
781 # If '--cached' is given, show summary between index and given commit,
782 # or between working tree and given commit
783 #
784 # $@ = [commit (default 'HEAD'),] requested paths (default all)
785 #
786 cmd_summary() {
787         summary_limit=-1
788         for_status=
789         diff_cmd=diff-index
790
791         # parse $args after "submodule ... summary".
792         while test $# -ne 0
793         do
794                 case "$1" in
795                 --cached)
796                         cached="$1"
797                         ;;
798                 --files)
799                         files="$1"
800                         ;;
801                 --for-status)
802                         for_status="$1"
803                         ;;
804                 -n|--summary-limit)
805                         summary_limit="$2"
806                         isnumber "$summary_limit" || usage
807                         shift
808                         ;;
809                 --summary-limit=*)
810                         summary_limit="${1#--summary-limit=}"
811                         isnumber "$summary_limit" || usage
812                         ;;
813                 --)
814                         shift
815                         break
816                         ;;
817                 -*)
818                         usage
819                         ;;
820                 *)
821                         break
822                         ;;
823                 esac
824                 shift
825         done
826
827         test $summary_limit = 0 && return
828
829         if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
830         then
831                 head=$rev
832                 test $# = 0 || shift
833         elif test -z "$1" || test "$1" = "HEAD"
834         then
835                 # before the first commit: compare with an empty tree
836                 head=$(git hash-object -w -t tree --stdin </dev/null)
837                 test -z "$1" || shift
838         else
839                 head="HEAD"
840         fi
841
842         if [ -n "$files" ]
843         then
844                 test -n "$cached" &&
845                 die "$(gettext "The --cached option cannot be used with the --files option")"
846                 diff_cmd=diff-files
847                 head=
848         fi
849
850         cd_to_toplevel
851         eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
852         # Get modified modules cared by user
853         modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
854                 sane_egrep '^:([0-7]* )?160000' |
855                 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
856                 do
857                         # Always show modules deleted or type-changed (blob<->module)
858                         if test "$status" = D || test "$status" = T
859                         then
860                                 printf '%s\n' "$sm_path"
861                                 continue
862                         fi
863                         # Respect the ignore setting for --for-status.
864                         if test -n "$for_status"
865                         then
866                                 name=$(git submodule--helper name "$sm_path")
867                                 ignore_config=$(get_submodule_config "$name" ignore none)
868                                 test $status != A && test $ignore_config = all && continue
869                         fi
870                         # Also show added or modified modules which are checked out
871                         GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
872                         printf '%s\n' "$sm_path"
873                 done
874         )
875
876         test -z "$modules" && return
877
878         git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
879         sane_egrep '^:([0-7]* )?160000' |
880         cut -c2- |
881         while read -r mod_src mod_dst sha1_src sha1_dst status name
882         do
883                 if test -z "$cached" &&
884                         test $sha1_dst = 0000000000000000000000000000000000000000
885                 then
886                         case "$mod_dst" in
887                         160000)
888                                 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
889                                 ;;
890                         100644 | 100755 | 120000)
891                                 sha1_dst=$(git hash-object $name)
892                                 ;;
893                         000000)
894                                 ;; # removed
895                         *)
896                                 # unexpected type
897                                 eval_gettextln "unexpected mode \$mod_dst" >&2
898                                 continue ;;
899                         esac
900                 fi
901                 missing_src=
902                 missing_dst=
903
904                 test $mod_src = 160000 &&
905                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
906                 missing_src=t
907
908                 test $mod_dst = 160000 &&
909                 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
910                 missing_dst=t
911
912                 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
913
914                 total_commits=
915                 case "$missing_src,$missing_dst" in
916                 t,)
917                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_src")"
918                         ;;
919                 ,t)
920                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commit \$sha1_dst")"
921                         ;;
922                 t,t)
923                         errmsg="$(eval_gettext "  Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
924                         ;;
925                 *)
926                         errmsg=
927                         total_commits=$(
928                         if test $mod_src = 160000 && test $mod_dst = 160000
929                         then
930                                 range="$sha1_src...$sha1_dst"
931                         elif test $mod_src = 160000
932                         then
933                                 range=$sha1_src
934                         else
935                                 range=$sha1_dst
936                         fi
937                         GIT_DIR="$name/.git" \
938                         git rev-list --first-parent $range -- | wc -l
939                         )
940                         total_commits=" ($(($total_commits + 0)))"
941                         ;;
942                 esac
943
944                 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
945                 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
946                 if test $status = T
947                 then
948                         blob="$(gettext "blob")"
949                         submodule="$(gettext "submodule")"
950                         if test $mod_dst = 160000
951                         then
952                                 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
953                         else
954                                 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
955                         fi
956                 else
957                         echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
958                 fi
959                 if test -n "$errmsg"
960                 then
961                         # Don't give error msg for modification whose dst is not submodule
962                         # i.e. deleted or changed to blob
963                         test $mod_dst = 160000 && echo "$errmsg"
964                 else
965                         if test $mod_src = 160000 && test $mod_dst = 160000
966                         then
967                                 limit=
968                                 test $summary_limit -gt 0 && limit="-$summary_limit"
969                                 GIT_DIR="$name/.git" \
970                                 git log $limit --pretty='format:  %m %s' \
971                                 --first-parent $sha1_src...$sha1_dst
972                         elif test $mod_dst = 160000
973                         then
974                                 GIT_DIR="$name/.git" \
975                                 git log --pretty='format:  > %s' -1 $sha1_dst
976                         else
977                                 GIT_DIR="$name/.git" \
978                                 git log --pretty='format:  < %s' -1 $sha1_src
979                         fi
980                         echo
981                 fi
982                 echo
983         done
984 }
985 #
986 # List all submodules, prefixed with:
987 #  - submodule not initialized
988 #  + different revision checked out
989 #
990 # If --cached was specified the revision in the index will be printed
991 # instead of the currently checked out revision.
992 #
993 # $@ = requested paths (default to all)
994 #
995 cmd_status()
996 {
997         # parse $args after "submodule ... status".
998         while test $# -ne 0
999         do
1000                 case "$1" in
1001                 -q|--quiet)
1002                         GIT_QUIET=1
1003                         ;;
1004                 --cached)
1005                         cached=1
1006                         ;;
1007                 --recursive)
1008                         recursive=1
1009                         ;;
1010                 --)
1011                         shift
1012                         break
1013                         ;;
1014                 -*)
1015                         usage
1016                         ;;
1017                 *)
1018                         break
1019                         ;;
1020                 esac
1021                 shift
1022         done
1023
1024         {
1025                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1026                 echo "#unmatched" $?
1027         } |
1028         while read -r mode sha1 stage sm_path
1029         do
1030                 die_if_unmatched "$mode" "$sha1"
1031                 name=$(git submodule--helper name "$sm_path") || exit
1032                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1033                 if test "$stage" = U
1034                 then
1035                         say "U$sha1 $displaypath"
1036                         continue
1037                 fi
1038                 if ! git submodule--helper is-active "$sm_path" ||
1039                 {
1040                         ! test -d "$sm_path"/.git &&
1041                         ! test -f "$sm_path"/.git
1042                 }
1043                 then
1044                         say "-$sha1 $displaypath"
1045                         continue;
1046                 fi
1047                 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1048                 then
1049                         set_name_rev "$sm_path" "$sha1"
1050                         say " $sha1 $displaypath$revname"
1051                 else
1052                         if test -z "$cached"
1053                         then
1054                                 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
1055                         fi
1056                         set_name_rev "$sm_path" "$sha1"
1057                         say "+$sha1 $displaypath$revname"
1058                 fi
1059
1060                 if test -n "$recursive"
1061                 then
1062                         (
1063                                 prefix="$displaypath/"
1064                                 sanitize_submodule_env
1065                                 wt_prefix=
1066                                 cd "$sm_path" &&
1067                                 eval cmd_status
1068                         ) ||
1069                         die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1070                 fi
1071         done
1072 }
1073 #
1074 # Sync remote urls for submodules
1075 # This makes the value for remote.$remote.url match the value
1076 # specified in .gitmodules.
1077 #
1078 cmd_sync()
1079 {
1080         while test $# -ne 0
1081         do
1082                 case "$1" in
1083                 -q|--quiet)
1084                         GIT_QUIET=1
1085                         shift
1086                         ;;
1087                 --recursive)
1088                         recursive=1
1089                         shift
1090                         ;;
1091                 --)
1092                         shift
1093                         break
1094                         ;;
1095                 -*)
1096                         usage
1097                         ;;
1098                 *)
1099                         break
1100                         ;;
1101                 esac
1102         done
1103         cd_to_toplevel
1104         {
1105                 git submodule--helper list --prefix "$wt_prefix" "$@" ||
1106                 echo "#unmatched" $?
1107         } |
1108         while read -r mode sha1 stage sm_path
1109         do
1110                 die_if_unmatched "$mode" "$sha1"
1111
1112                 # skip inactive submodules
1113                 if ! git submodule--helper is-active "$sm_path"
1114                 then
1115                         continue
1116                 fi
1117
1118                 name=$(git submodule--helper name "$sm_path")
1119                 url=$(git config -f .gitmodules --get submodule."$name".url)
1120
1121                 # Possibly a url relative to parent
1122                 case "$url" in
1123                 ./*|../*)
1124                         # rewrite foo/bar as ../.. to find path from
1125                         # submodule work tree to superproject work tree
1126                         up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1127                         # guarantee a trailing /
1128                         up_path=${up_path%/}/ &&
1129                         # path from submodule work tree to submodule origin repo
1130                         sub_origin_url=$(git submodule--helper resolve-relative-url "$url" "$up_path") &&
1131                         # path from superproject work tree to submodule origin repo
1132                         super_config_url=$(git submodule--helper resolve-relative-url "$url") || exit
1133                         ;;
1134                 *)
1135                         sub_origin_url="$url"
1136                         super_config_url="$url"
1137                         ;;
1138                 esac
1139
1140                 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
1141                 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1142                 git config submodule."$name".url "$super_config_url"
1143
1144                 if test -e "$sm_path"/.git
1145                 then
1146                 (
1147                         sanitize_submodule_env
1148                         cd "$sm_path"
1149                         remote=$(get_default_remote)
1150                         git config remote."$remote".url "$sub_origin_url"
1151
1152                         if test -n "$recursive"
1153                         then
1154                                 prefix="$prefix$sm_path/"
1155                                 eval cmd_sync
1156                         fi
1157                 )
1158                 fi
1159         done
1160 }
1161
1162 cmd_absorbgitdirs()
1163 {
1164         git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
1165 }
1166
1167 # This loop parses the command line arguments to find the
1168 # subcommand name to dispatch.  Parsing of the subcommand specific
1169 # options are primarily done by the subcommand implementations.
1170 # Subcommand specific options such as --branch and --cached are
1171 # parsed here as well, for backward compatibility.
1172
1173 while test $# != 0 && test -z "$command"
1174 do
1175         case "$1" in
1176         add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
1177                 command=$1
1178                 ;;
1179         -q|--quiet)
1180                 GIT_QUIET=1
1181                 ;;
1182         -b|--branch)
1183                 case "$2" in
1184                 '')
1185                         usage
1186                         ;;
1187                 esac
1188                 branch="$2"; shift
1189                 ;;
1190         --cached)
1191                 cached="$1"
1192                 ;;
1193         --)
1194                 break
1195                 ;;
1196         -*)
1197                 usage
1198                 ;;
1199         *)
1200                 break
1201                 ;;
1202         esac
1203         shift
1204 done
1205
1206 # No command word defaults to "status"
1207 if test -z "$command"
1208 then
1209     if test $# = 0
1210     then
1211         command=status
1212     else
1213         usage
1214     fi
1215 fi
1216
1217 # "-b branch" is accepted only by "add"
1218 if test -n "$branch" && test "$command" != add
1219 then
1220         usage
1221 fi
1222
1223 # "--cached" is accepted only by "status" and "summary"
1224 if test -n "$cached" && test "$command" != status && test "$command" != summary
1225 then
1226         usage
1227 fi
1228
1229 "cmd_$command" "$@"